"########################## Libraries #########################################################"
import pandapower as pp, pandas as pd
from pandapower import networks
import pandapower.networks as nw
from pandapower import toolbox
import networkx as nx
import pandapower.control as control
import matplotlib.pyplot as plt
import pandapower.plotting as plot
from pandapower.plotting import simple_plot
pd.options.display.max_columns = None
import pandapower.timeseries as timeseries
from pandapower.timeseries.data_sources.frame_data import DFData
import numpy as np
import numpy.random as random
import os

"#################### 39 Bus System creation ################################################"
net = networks.case39()
net1 = networks.case39()
toolbox.reindex_buses(net1, dict(zip(range(39),range(1,40))))
toolbox.reindex_buses(net,  dict(zip(range(39),range(1,40))))

#net1.ext_grid.vm_pu = 1.0
#net1.bus.max_vm_pu = 1.05
#net1.bus.min_vm_pu = 0.95

"######## Creating results list ####################"
rows, cols = (2484, 45)

results = [[0 for i in range(cols)] for j in range(rows)]


rowsl, colsl = (21,55)
results_loads = [[0 for i in range(colsl)] for j in range(rowsl)]  

"################# Create switches for lines (39 Bus System) #################################" 
pp.create_switch(net1, bus = 1, element = 0, et = 'l', closed=True, type = 'CB')
pp.create_switch(net1, bus = 1, element = 1, et = 'l', closed=True, type = 'CB')
pp.create_switch(net1, bus = 2, element = 2, et = 'l', closed=True, type = 'CB')
pp.create_switch(net1, bus = 2, element = 3, et = 'l', closed=True, type = 'CB')
pp.create_switch(net1, bus = 3, element = 4, et = 'l', closed=True, type = 'CB')
pp.create_switch(net1, bus = 3, element = 5, et = 'l', closed=True, type = 'CB')
pp.create_switch(net1, bus = 4, element = 6, et = 'l', closed=True, type = 'CB')
pp.create_switch(net1, bus = 4, element = 7, et = 'l', closed=True, type = 'CB')
pp.create_switch(net1, bus = 5, element = 8, et = 'l', closed=True, type = 'CB')
pp.create_switch(net1, bus = 5, element = 9, et = 'l', closed=True, type = 'CB')
pp.create_switch(net1, bus = 6, element = 10, et = 'l', closed=True, type = 'CB')
pp.create_switch(net1, bus = 6, element = 11, et = 'l', closed=True, type = 'CB')
pp.create_switch(net1, bus = 7, element = 12, et = 'l', closed=True, type = 'CB')
pp.create_switch(net1, bus = 8, element = 13, et = 'l', closed=True, type = 'CB')
pp.create_switch(net1, bus = 9, element = 14, et = 'l', closed=True, type = 'CB')
pp.create_switch(net1, bus = 10, element = 15, et = 'l', closed=True, type = 'CB')
pp.create_switch(net1, bus = 10, element = 16, et = 'l', closed=True, type = 'CB')
pp.create_switch(net1, bus = 13, element = 17, et = 'l', closed=True, type = 'CB')
pp.create_switch(net1, bus = 14, element = 18, et = 'l', closed=True, type = 'CB')
pp.create_switch(net1, bus = 15, element = 19, et = 'l', closed=True, type = 'CB')
pp.create_switch(net1, bus = 16, element = 20, et = 'l', closed=True, type = 'CB')
pp.create_switch(net1, bus = 16, element = 21, et = 'l', closed=True, type = 'CB')
pp.create_switch(net1, bus = 16, element = 22, et = 'l', closed=True, type = 'CB')
pp.create_switch(net1, bus = 16, element = 23, et = 'l', closed=True, type = 'CB')
pp.create_switch(net1, bus = 17, element = 24, et = 'l', closed=True, type = 'CB')
pp.create_switch(net1, bus = 17, element = 25, et = 'l', closed=True, type = 'CB')
pp.create_switch(net1, bus = 21, element = 26, et = 'l', closed=True, type = 'CB')
pp.create_switch(net1, bus = 22, element = 27, et = 'l', closed=True, type = 'CB')
pp.create_switch(net1, bus = 23, element = 28, et = 'l', closed=True, type = 'CB')
pp.create_switch(net1, bus = 23, element = 29, et = 'l', closed=True, type = 'CB')
pp.create_switch(net1, bus = 25, element = 30, et = 'l', closed=True, type = 'CB')
pp.create_switch(net1, bus = 26, element = 31, et = 'l', closed=True, type = 'CB')
pp.create_switch(net1, bus = 26, element = 32, et = 'l', closed=True, type = 'CB')
pp.create_switch(net1, bus = 26, element = 33, et = 'l', closed=True, type = 'CB')
pp.create_switch(net1, bus = 28, element = 34, et = 'l', closed=True, type = 'CB')

"############### Create switches for transformers #############################################"
pp.create_switch(net1, bus = 2 , element = 0, et = 't', closed =True, type = 'CB')
pp.create_switch(net1, bus = 6 , element = 1, et = 't', closed =True, type = 'CB')
pp.create_switch(net1, bus = 10 , element = 2, et = 't', closed =True, type = 'CB')
pp.create_switch(net1, bus = 12 , element = 3, et = 't', closed =True, type = 'CB')
pp.create_switch(net1, bus = 12 , element = 4, et = 't', closed =True, type = 'CB')
pp.create_switch(net1, bus = 19 , element = 5, et = 't', closed =True, type = 'CB')
pp.create_switch(net1, bus = 19 , element = 6, et = 't', closed =True, type = 'CB')
pp.create_switch(net1, bus = 20 , element = 7, et = 't', closed =True, type = 'CB')
pp.create_switch(net1, bus = 22 , element = 8, et = 't', closed =True, type = 'CB')
pp.create_switch(net1, bus = 25 , element = 9, et = 't', closed =True, type = 'CB')
pp.create_switch(net1, bus = 29 , element = 10, et = 't', closed =True, type = 'CB')


" ########################## Functions ###################################################################"

"################## Function to open switch to trip branch ##################################"
def opswitch(switch_id):
    net1.switch.closed[switch_id] = False
    if switch_id < 35:
        line_outserv = net1.switch.element[switch_id]
        net1.line.in_service[line_outserv] = False
        results[number_of_steps][0] = net1.switch.element[switch_id] + 1
    else:
        trafo_outserv = net1.switch.element[switch_id]
        net1.trafo.in_service[trafo_outserv] = False
        results[number_of_steps][0] = net1.switch.element[switch_id] + 36
    
"################### Function to open switch to trip branch with probability p2 ############## "
def opswitch_casc(switch_id):    
    p2 = 0.9 # probability that a switch does trip 
    p = (np.random.rand() < p2)
    if (p == True):
        net1.switch.closed[switch_id] = False

        if switch_id < 35:
            line_outserv = net1.switch.element[switch_id]
            net1.line.in_service[line_outserv] = False
            
        else:
            trafo_outserv = net1.switch.element[switch_id]
            net1.trafo.in_service[trafo_outserv] = False    
        return 1
    else:

        return 0

"################### Function to close switch for net1 ############################################"
def clswitch(switch_id):
    net1.switch.closed[switch_id] = True

    if switch_id < 35:
        line_outserv = net1.switch.element[switch_id]
        net1.line.in_service[line_outserv] = True
    else:
        trafo_outserv = net1.switch.element[switch_id]
        net1.trafo.in_service[trafo_outserv] = True
    
"##########Function to determine how the cyber system is affected by switches ################"
def busout(switch_id,k):
    p1 = 0.4 #probability that the cyber node disconnects
    p3 = 0.01 # probability that an nearby node is affected 
    
    p = (np.random.rand() < p1)
    
    if switch_id < 35:  
        b_in = net1.line.from_bus[switch_id]  
        for h in range(0,len(cyber_physical),1):
            if cyber_physical[h][1] == b_in:
                cyber_bus1 = cyber_physical[h][0]
        if (p == True):
            cyber_adj = list(cyber.adj[cyber_bus1])
            cyber.remove_node(cyber_bus1)
            results[number_of_steps][k] = cyber_bus1 + 100
            k +=1
            #print ("Cyber node", cyber_bus1 , "disconnected")
            for i in cyber_adj:
                p2 = (np.random.rand() < p3)
                if (p2 == True) and (cyber.has_node(i) == True):
                    cyber.remove_node(i)
                    results[number_of_steps][k] = i + 100
                    k +=1
                    #print("Hidden failure to cyber node:", i)
    else:
        b_trafo = net1.switch.bus[switch_id] 
        for h in range(0,len(cyber_physical),1):
            if cyber_physical[h][1] == b_trafo:
                cyber_bus1 = cyber_physical[h][0]
        if (p == True):
            cyber_adj = list(cyber.adj[cyber_bus1])
            cyber.remove_node(cyber_bus1)
            results[number_of_steps][k] = cyber_bus1 + 100
            k +=1

            for i in cyber_adj:
                p2 = (np.random.rand() < p3)
                if (p2 == True) and (cyber.has_node(i-1) == True):
                    cyber.remove_node(i)
                    results[number_of_steps][k] = i + 100
                    k +=1

    
    return k
"###########################################################################"



'################ Result Data (after running the power flow) ###################'

#print("\n\n Line results:")
#print(net1.res_line.iloc[:,[8,13]])

#print('\n\n Transformer data:')
#print(net1.res_trafo.iloc[:,[6,12]])

#print("\n\n Generator results")
#print(net1.res_gen.iloc[:,[0,3]])

#print("\n\n External grid results")
#print(net1.res_ext_grid.iloc[:,[0]])

#print('\n\n Load data:')
#print(net1.res_load.iloc[:,[0]])

#plot.simple_plot(net1, respect_switches=True, switch_distance=3.0, plot_line_switches=True, show_plot=True)

"################## Creating communication (cyber) system and degree-to-degree connection ##################################"

"####################### Import existing graph ########################################"

df2 = pd.read_excel (r'cyber_39_nodes.xlsx')
df3 = pd.read_excel (r'cyber_39_edges.xlsx')
system_nodes = df2.values.tolist()
system_edges = df3.values.tolist()

cyber1 = nx.Graph()

for i in range(0,len(system_nodes),1):
    cyber1.add_node(system_nodes[i][0])
    
for i in range(0,len(system_edges),1):
    cyber1.add_edge(system_edges[i][1], system_edges[i][2])
    
"############### Generate a new graph for cyber system and save it to excel #########################"
#cyber1 = nx.barabasi_albert_graph(39, 2, seed=None)
#cyber_39_buses = cyber1.nodes
#cyber_39_edges = cyber1.edges
#df2 = pd.DataFrame(data = cyber_39_buses)
#df3 = pd.DataFrame(data = cyber_39_edges)
#df2.to_excel("cyber_39_nodes.xlsx")
#df3.to_excel("cyber_39_edges.xlsx")

"############## Plot Graph and connect cyber and physical layers ###############################################"
nx.draw(cyber1, with_labels=True, font_weight='bold')

rows, cols = (39, 2)

cyber_list = [[0 for i in range(cols)] for j in range(rows)]
physi_list = [[0 for i in range(cols)] for j in range(rows)]
cyber_physical = [[0 for i in range(cols)] for j in range(rows)]

for i in range(0,39,1):
    cyber_list[i][1]= cyber1.degree[i]
    cyber_list[i][0]= i
    physi_list[i][1]= len(pp.get_connected_buses(net1, i + 1 , consider=('l', 's', 't'), respect_switches=False, respect_in_service=False))
    physi_list[i][0]= i + 1   

cyber_list = sorted(cyber_list,key=lambda l:l[1], reverse=True)
physi_list = sorted(physi_list,key=lambda l:l[1], reverse=True)

df4 = pd.DataFrame(data = cyber_list)
df5 = pd.DataFrame(data = physi_list)
df4.to_excel("39_bus_cyber_degree.xlsx")
df5.to_excel("39_bus_physical_degree.xlsx")

for i in range(0,len(cyber_list),1):
    cyber_physical[i][0] = cyber_list[i][0]
    cyber_physical[i][1] = physi_list[i][0]

"####################################################################################################"    
"#########################    Main Operation   #######################################################"
number_of_steps = 0

for w in range (0,54,1):
    
    for i in range(0,len(net1.load),1):
         net1.load.p_mw[i] = np.random.uniform(0.0, net.load.p_mw[i]*1.5, size = None)
         results_loads[i][w] = net1.load.p_mw[i]
     
    print("\n\n",w)
    
    for i in range (0,46,1):

        opswitch(i)
        k = 1
        cyber = cyber1.copy(as_view=False)

        k = busout(i,k)
        flag = 1
        
        while flag == 1:
            flag1 = 0
            line_overl = -1
            line_overl_2 = -1
            line_overl_t = -1
            line_max = 0
            pp.rundcpp(net1)

            for j in range(0,35,1):
                if (net1.res_line.i_ka[j] >= 1.3):
                    line_overl= j
                    ph_bus = net1.line.from_bus[line_overl]
                    for h in range(0,len(cyber_physical),1):
                        if cyber_physical[h][1] == ph_bus:
                            cyber_bus = cyber_physical[h][0]
                            
                    if cyber.has_node(cyber_bus) == False:
                        line_overl = line_overl_2
                
                    if (line_overl >= 0):
                        line_overl_t = line_overl
                        z = net1.switch.element[line_overl]
                        if opswitch_casc(z) == 1:
                            results[number_of_steps][k] = line_overl + 1
                            k +=1

                            k = busout(z,k)
                            
            pp.rundcpp(net1)

            for j in range (0,35,1):
                if (net1.res_line.i_ka[j] >= 1.3) and (line_overl_t >=0):
                    flag1 = 1
                elif (net1.res_line.i_ka[j] >= 1.3) and (line_overl_t == -1 ):
                    line_overl= j
                    z = net1.switch.element[line_overl]
                    if opswitch_casc(z) == 1:
                        results[number_of_steps][k] = line_overl + 1
                        k +=1
                    flag1 = 1
                    
            if (flag1 == 1):
                flag = 1
            else:
                flag = 0
               
        number_of_steps += 1          
        for h in range (0,46,1):
            clswitch(h)

"################### Dataframes/ Excel export ###############################"        
df = pd.DataFrame(data=results)
df1 = pd.DataFrame(data = results_loads)



df.to_excel("Cascading_failures_39 bus.xlsx") 
df1.to_excel("Var_loads_39 bus.xlsx")        